get2/urls.py
from django.conf.urls import *
from django.views.generic import TemplateView
from dajaxice.core import dajaxice_autodiscover, dajaxice_config

dajaxice_autodiscover()

# Uncomment the next two lines to enable the admin:
# from django.contrib import admin
# admin.autodiscover()

urlpatterns = patterns('',
    url(dajaxice_config.dajaxice_url, include('dajaxice.urls')),
    # statistiche
    url(r'^statistiche/', include('statistiche.urls')),
    url(r'^persone/', include('persone.urls')),
    #url(r'^gestione/', include('gestione.urls')),
)

urlpatterns += patterns('get2.calendario',
	# calendario
	(r'^$','views.home'),
	(r'^calendario/$', 'views.home'),
	(r'^touch/(?P<v>\w+)$', 'views.touch'),
	(r'^backup/(?P<password>\w+)$', 'views.backup'),
	(r'^calendario/(?P<cal_id>\w+)/$', 'views.calendario'),
	(r'^stampa_calendario/(?P<cal_id>\w+)/$', 'views.stampa_calendario'),
	(r'^calendario/(?P<cal_id>\w+)/(?P<azione>\w+)$', 'views.calendarioazione'),
	# utenti
	(r'^utenti/$', 'views.elenco_utente'),
	(r'^utenti/nuovo/$', 'views.nuovo_utente'),
	(r'^utenti/modifica/(?P<utente_id>\w+)/password/$', 'views.modifica_password_utente'),
	(r'^utenti/modifica/(?P<utente_id>\w+)/password_personale/$', 'views.modifica_password_personale'),
	(r'^utenti/modifica/(?P<utente_id>\w+)/$', 'views.modifica_utente'),
	(r'^utenti/elimina/(?P<utente_id>\w+)/$', 'views.elimina_utente'),
	# mansioni
	(r'^impostazioni/mansione/nuovo/(?P<padre_id>\w+)/$', 'views.nuovo_mansione'),
	(r'^impostazioni/mansione/modifica/(?P<mansione_id>\w+)/$', 'views.modifica_mansione'),
	(r'^impostazioni/mansione/elimina/(?P<mansione_id>\w+)/$', 'views.elimina_mansione'),
	# turno
	(r'^turno/(?P<cal_id>\w+)/nuovo/$', 'views.nuovo_turno'),
	(r'^turno/modifica/(?P<turno_id>\w+)/$', 'views.modifica_turno'),
	(r'^turno/elimina/(?P<turno_id>\w+)/$', 'views.elimina_turno'),
	(r'^turno/elimina_occorrenza/(?P<occorrenza_id>\w+)/$', 'views.elimina_turno_occorrenza_succ'),
	(r'^turno/elimina_occorrenza_tot/(?P<occorrenza_id>\w+)/$', 'views.elimina_turno_occorrenza'),
	(r'^cerca_persona/(?P<turno_id>\w+)/(?P<mansione_id>\w+)', 'views.cerca_persona'),
	(r'^disponibilita/(?P<turno_id>\w+)/(?P<mansione_id>\w+)/(?P<persona_id>\w+)/(?P<disponibilita>\w+)', 'views.disponibilita_url'),
	(r'^rimuovi_disponibilita/(?P<disp_id>\w+)', 'views.rimuovi_disponibilita'),
	(r'^disponibilita_gruppo/(?P<turno_id>\w+)/(?P<gruppo_id>\w+)/', 'views.disponibilita_gruppo'),
	#(r'^turno/cerca_persona/(?P<turno_id>\w+)/(?P<mansione_id>\w+)/$', 'views.turno_cerca'),
	# impostazioni
	(r'^impostazioni/$', 'views.impostazioni'),
	(r'^impostazioni/calendario/nuovo/$', 'views.nuovo_calendario'),
	(r'^impostazioni/calendario/modifica/(?P<cal_id>\w+)/$', 'views.modifica_calendario'),
	(r'^impostazioni/calendario/elimina/(?P<cal_id>\w+)/$', 'views.elimina_calendario'),
	(r'^impostazioni/tipo_turno/nuovo/$', 'views.nuovo_tipo_turno'),
	(r'^impostazioni/tipo_turno/modifica/(?P<tipo_turno_id>\w+)/$', 'views.modifica_tipo_turno'),
	(r'^impostazioni/tipo_turno/elimina/(?P<tipo_turno_id>\w+)/$', 'views.elimina_tipo_turno'),
	(r'^impostazioni/tipo_turno/aggiungi_requisito/(?P<tipo_turno_id>\w+)/$', 'views.nuovo_requisito'),
	(r'^impostazioni/requisito/modifica/(?P<requisito_id>\w+)/$', 'views.modifica_requisito'),
	(r'^impostazioni/requisito/elimina/(?P<requisito_id>\w+)/$', 'views.elimina_requisito'),
	(r'^impostazioni/notifica/nuovo/$', 'views.nuovo_impostazioni_notifica'),
	(r'^impostazioni/notifica/modifica/(?P<impostazioni_notifica_id>\w+)/$', 'views.modifica_impostazioni_notifica'),
	(r'^impostazioni/notifica/elimina/(?P<impostazioni_notifica_id>\w+)/$', 'views.elimina_impostazioni_notifica'),
	# notifiche
   	(r'^notifiche/$', 'views.elenco_notifica'),
   	(r'^notifiche/elimina/(?P<notifica_id>\w+)/$', 'views.elimina_notifica'),
)

urlpatterns += patterns('django.contrib.auth.views',
    #utente
    #(r'^utente/nuovo/$', 'turni.views.nuovoutente'),
    (r'^utenti/reset/$', 'password_reset'),
    (r'^utenti/reset/(?P<uidb36>[0-9A-Za-z]+)-(?P<token>.+)/$', 'password_reset_confirm'),
    (r'^utenti/reset/completa/$', 'password_reset_complete'),
    (r'^utenti/reset/ok/$', 'password_reset_done'),
    )

urlpatterns += patterns('',
    (r'^accounts/login/$', 'django.contrib.auth.views.login', {'template_name':'registration/login.html'} ),
    (r'^accounts/logout/$', 'django.contrib.auth.views.logout', {'next_page': '/'}),
    )

#urlpatterns = patterns('',
#    url(r'', include('gcm.urls')),
#)

statistiche/urls.py
from django.conf.urls import patterns, include, url

urlpatterns = patterns('statistiche',
	# statistiche
	url(r'^$', 'views.statistiche'),
	)

statistiche/models.py
from django.db import models
from django import forms
# Create your models here.
from crispy_forms.helper import FormHelper
from crispy_forms.layout import Layout, Fieldset, ButtonHolder, Submit, Field, MultiField, HTML, Button
from crispy_forms.bootstrap import *
import calendar,datetime,locale
from persone.models import Mansione, Gruppo
from dateutil.relativedelta import relativedelta
class FiltroStatistiche(forms.Form):
	lista_gruppi = [('all','senza gruppo')]
	lista_mansioni = Mansione.objects.exclude(escludi_stat=True).values_list('id','nome')
	lista_gruppi += Gruppo.objects.exclude(escludi_stat=True).values_list('id','nome')
	mansioni = forms.MultipleChoiceField( label = "",	choices = lista_mansioni, initial = [x[0] for x in lista_mansioni], required = False,  widget = forms.CheckboxSelectMultiple,)
	gruppi = forms.MultipleChoiceField( label = "",	choices = lista_gruppi,initial = [x[0] for x in lista_gruppi],  required = False,  widget = forms.CheckboxSelectMultiple,)
	start =  forms.DateField(label = "dal:", required = False, initial=(datetime.datetime.now() + relativedelta( years = -1 )).strftime("%d/%m/%Y"))
	stop = forms.DateField(label = "al:", required = False, initial=datetime.datetime.now().date().strftime("%d/%m/%Y"))
	def __init__(self, *args, **kwargs):
		self.helper = FormHelper()
		self.helper.form_id = 'FiltroStatistiche'
		self.helper.layout = Layout(
			
			Field('start', type="hidden"),
			Field('stop', type="hidden"),
			HTML('<div class="row">'),
			Div(
				Fieldset('<h7>Mansioni</h7>',
					InlineCheckboxes('mansioni', css_class="mansioni"),
				),
				css_class="span4",
			),	
			Div(
				Fieldset('<h7>Gruppi</h7>',
					InlineCheckboxes('gruppi', css_class="gruppi"),
				),
				css_class="span3",
			),
			HTML('</div></br>'),
			
			Button('save', 'Filtra', onclick="aggiorna_statistiche();", css_class="btn-primary btn-small"),
			Button('cancel', 'Annulla', onclick="reset();", css_class="btn-small"),
			
			)
		self.helper.form_method = 'post'
		#self.helper.form_action = 'submit_survey'
		super(FiltroStatistiche, self).__init__(*args, **kwargs)

statistiche/views.py
# Create your views here.
from django.http import HttpResponse, HttpResponseRedirect, QueryDict
from persone.models import *
from get2.calendario.models import *
from django.shortcuts import render_to_response, redirect, render
import calendar,datetime,locale
from django.db.models import Q, Count, Sum
from django.core.urlresolvers import reverse
from django.contrib.auth.models import User
from django.template import RequestContext
from django.contrib.admin.views.decorators import staff_member_required
from django.contrib.auth.decorators import user_passes_test
from django.contrib.auth.decorators import login_required
from statistiche.models import FiltroStatistiche
import pdb

#### inizio statistiche ####
elenco_statistiche=("Turni totali",
				"Punteggi totali",
			)

@login_required
def statistiche(request):
	#se l' intervallo non e specificato prendo tutto
	tot_turni, tot_punti =statistiche_intervallo(request)
	return render(request,'statistiche.html',{'tot_turni': tot_turni,'tot_punti': tot_punti,'FiltroStatistiche':FiltroStatistiche() ,'request':request})

import operator
from dateutil.relativedelta import relativedelta

def statistiche_intervallo(request, inizio = datetime.datetime.now() + relativedelta( years = -1 ), fine = datetime.datetime.now().date(), mansioni = Mansione.objects.all(), gruppi = Gruppo.objects.all(), senza_gruppo = True):
	tot_turni = []
	tot_punti = []
	#Turno.objects.earliest(field_name='inizio')
	if senza_gruppo:
		persone = Persona.objects.exclude(componenti_gruppo__escludi_stat=True).filter(Q(Q(componenti_gruppo__isnull=True) | Q(componenti_gruppo__in=gruppi))).distinct().values('id','nome','cognome')
		#print persone
	else:
		persone = Persona.objects.exclude(componenti_gruppo__escludi_stat=True).filter(componenti_gruppo__in=gruppi).values('id','nome','cognome')

	for p in persone:
		disp = Disponibilita.objects.values('turno__valore').filter(persona_id = p["id"], tipo = "Disponibile", turno__inizio__gte=inizio, turno__fine__lte=fine, mansione__in=mansioni.exclude(escludi_stat=True))
		p['tot_turni'] = disp.count()
		p['tot_punti'] = 0
		for d in disp:
			p['tot_punti'] += d['turno__valore']
		tot_turni.append(p)
		tot_punti.append(p)
	#import pdb; pdb.set_trace()
	tot_turni.sort(key=operator.itemgetter('tot_turni'), reverse=True)
	tot_punti.sort(key=operator.itemgetter('tot_punti'), reverse=True)
	return tot_turni, tot_punti
#### fine statistiche ####

statistiche/templates/statistiche.html
{% extends "base.html" %}
{% load static %}
{% load crispy_forms_tags %}

{% block head %}
	<script src="/static/js/highcharts/highcharts.js"></script>
	<!--[if lte IE 8]><script language="javascript" type="text/javascript" src="excanvas.min.js"></script><![endif]-->
	<script src="/static/js/jquery.tablesorter.min.js"></script>
	<script src="/static/js/jquery.tablesorter.widgets.min.js"></script>
	<script src="/static/js/jquery.tablesorter.widgets-filter-formatter.min.js"></script>
	<link href="/static/css/theme.bootstrap.css" rel="stylesheet">
	<script src="/static/jquery-ui.min.js"></script>
	<script type="text/javascript" src="/static/js/bootstrap-daterangepicker/moment.js"></script>
    <script type="text/javascript" src="/static/js/bootstrap-daterangepicker/daterangepicker.js"></script>
	<link rel="stylesheet" type="text/css" media="all" href="/static/js/bootstrap-daterangepicker/daterangepicker-bs2.css" />
{% endblock%}


{% block header %}
		<h4 class="header">Statistiche</h4>
{% endblock %}


{% block main %}

<script>
function aggiorna_statistiche(){
	mansioni = "";
	$('.mansioni:checkbox').each(function() {if (this.checked) {
        mansioni = mansioni + '_' + this.value;
    }});
    mansioni = mansioni.substr(1);
    if (mansioni==""){alert("seleziona almeno una mansione!"); return;} 		
    gruppi = "";
	$('.gruppi:checkbox').each(function() {if (this.checked) {
        gruppi = gruppi + '_' + this.value;
    }});
    gruppi = gruppi.substr(1);
    if (gruppi==""){alert("seleziona almeno un gruppo!"); return;}
    $('#loading').removeClass('hidden');
	Dajaxice.statistiche.aggiorna_statistiche(Dajax.process,{'da':$("#id_start").val(),'al':$("#id_stop").val(),'mansioni':mansioni,'gruppi':gruppi});

};

function dettagli_statistiche(id){
	mansioni = "";
	$('.mansioni:checkbox').each(function() {if (this.checked) {
        mansioni = mansioni + '_' + this.value;
    }});
    mansioni = mansioni.substr(1);
	Dajaxice.statistiche.dettaglio_turni(Dajax.process,{'da':$("#id_start").val(),'al':$("#id_stop").val(),'mansioni':mansioni,'id':id});
}

function generali(){
	Dajaxice.statistiche.statistiche_generali(Dajax.process,{'da':$("#id_start").val(),'al':$("#id_stop").val()});
}


function reset(){
	$("#id_start").val('');
	$("#id_stop").val('');
	$('.mansioni').prop('checked',true);
	$('.gruppi').prop('checked',true);
	$('#loading').removeClass('hidden');
	Dajaxice.statistiche.aggiorna_statistiche(Dajax.process,{'da':'0','al':'0','mansioni':'all','gruppi':'all'});
};
</script>

<div class="row-fluid">
	<div class="span5" id="filtri">
		<div class="box">
			<div class="box-content hide" id="filtro_statistiche">
				{% crispy FiltroStatistiche %}
			</div>
		</div>
	</div>
	<div class="span2">
		<div id="reportrange" class="pull-right btn" style="margin-right:10px; cursor: pointer;">
            <i class="icon-calendar icon-large"></i>
                <span></span> <b class="caret"></b>
        </div>
        <span class="pull-right btn" onclick="$('#filtro_statistiche').slideToggle();" style="margin-right:10px; cursor: pointer;"><i class="icon-filter"></i> Filtra</span>
	</div>
</div>
<div class="row-fluid">
	<div class="span7 tabbable" id="stat" style="padding:10px;">
		{% include "statistiche/statistiche.html" %}
	</div>
</div>

<script type="text/javascript">
	$(document).ready(function() {
		$('#reportrange').daterangepicker(
		{
		startDate: moment().subtract('years', 1),
		endDate: moment(),
		minDate: moment().subtract('years', 5),
		maxDate: moment(),
		//dateLimit: { days: 60 },
		showDropdowns: true,
		showWeekNumbers: false,
		timePicker: false,
		timePickerIncrement: 1,
		timePicker12Hour: true,
		ranges: {
		   'Ultimi 7 giorni': [moment().subtract('days', 6), moment()],
		   'Ultimi 30 giorni': [moment().subtract('days', 29), moment()],
		   'Questo Mese': [moment().startOf('month'), moment().endOf('month')],
		   'Ultimi 6 mesi': [moment().subtract('month', 1).startOf('month'), moment().subtract('month', 1).endOf('month')]
		},
		opens: 'left',
		buttonClasses: ['btn btn-default'],
		applyClass: 'btn-small btn-primary',
		cancelClass: 'btn-small',
		format: 'DD/MM/YYYY',
		separator: ' to ',
		locale: {
		    applyLabel: 'Invia',
		    fromLabel: 'Dal',
		    toLabel: 'Al',
		    customRangeLabel: 'Scegli Intervallo',
		    daysOfWeek: ['Dom', 'Lun', 'Mar', 'Mer', 'Gio', 'Ven','Sab'],
		    monthNames: ['Gennaio', 'Febbraio', 'Marzo', 'Aprile', 'Maggio', 'Giugno', 'Luglio', 'Agosto', 'Settembre', 'Ottobre', 'Novembre', 'Dicembre'],
		    firstDay: 1
		}
		},
		function(start, end) {
		console.log("Callback has been called!");
		$('#reportrange span').html(start.format('D MMMM, YYYY') + ' - ' + end.format('D MMMM, YYYY'));
		$("#id_start")[0].value = start.format('D/M/YYYY');
		$("#id_stop")[0].value = end.format('D/M/YYYY');
		aggiorna_statistiche();
		}
		);
		//Set the initial state of the picker label
		$('#reportrange span').html(moment().subtract('years', 1).format('D MMMM, YYYY') + ' - ' + moment().format('D MMMM, YYYY'));
		$("#id_start")[0].value = moment().subtract('years', 1).format('D/M/YYYY');
		$("#id_stop")[0].value = moment().format('D/M/YYYY');
	});
</script>


{% endblock %}